#include <vxWorks.h>
#include <taskLib.h>
#include <sysLib.h>
#include <semLib.h>
#include <stdio.h>

void task(int task_id);

SEM_ID semMutex;
int liczba_czyt=0;
int shared_var=0;

void main(void)
{
	int ret1, ret2, ret3, ret4;
	// Utwrz odblokowany semafor:
	semMutex=semBCreate(SEM_Q_PRIORITY,SEM_EMPTY);
	
	
	ret1=taskSpawn("it_waits",100,0,4096,(FUNCPTR)task,1,0,0,0,0,0,0,0,0,0);
	ret2=taskSpawn("it_sends",110,0,4096,(FUNCPTR)task,2,0,0,0,0,0,0,0,0,0);
	taskSuspend(0);
}


void task(int task_id)
{
	static int a=0;
	
	switch (task_id)
	{
	case 1: //Timeout na semaforze:
		{
			STATUS sem_ret_val;
			printf("Oczekiwanie:\n");
			sem_ret_val = semTake(semMutex,sysClkRateGet()*3);
			if(sem_ret_val==ERROR)
				printf("Nastapilo przeterminowanie\n");
			else
				printf("Nastapila synchronizacja\n");
			break;
		}
	case 2:
		{
			printf("Zaraz wysle sygnal synchronizacji\n");
			taskDelay(sysClkRateGet()*4);
			semGive(semMutex);
			break;
		}
	}
	taskSuspend(0);
}